﻿using Exam.Infrastructure.Data.Interface;
using Exam.Infrastructure.Enums;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Text.Json.Serialization;
using System.Threading.Tasks;

namespace Exam.Infrastructure.Data.Entity
{
    /// <summary>
    /// Dto基类
    /// </summary>
    public class ActionRequest:IActionRequest
    {
        /// <summary>
        /// 主键
        /// </summary>
        [Description("主键")]
        public string Id { get; set; }

        /// <summary>
        /// 排序
        /// </summary>
        [Description("排序")]
        public int SortIndex { get; set; }

        /// <summary>
        /// 状态
        /// </summary>
        [Description("状态")]
        public int Status { get; set; }

        /// <summary>
        /// 用户ID
        /// </summary>
        [Description("用户ID")]
        [JsonIgnore]
        public string UserId { get; set; }

        /// <summary>
        /// 用户名称
        /// </summary>
        [Description("用户名称")]
        [JsonIgnore]
        public string UserName { get; set; }

        /// <summary>
        /// 组织Id
        /// </summary>
        [Description("组织Id")]
        [JsonIgnore]
        public string OrgId { get; set; }

        /// <summary>
        /// 组织名称
        /// </summary>
        [Description("组织名称")]
        [JsonIgnore]
        public string OrgName { get; set; }

        /// <summary>
        /// 组织层级
        /// </summary>
        [Description("组织层级")]
        [JsonIgnore]
        public int OrgLevel { get; set; }


        /// <summary>
        /// 区域
        /// </summary>
        [Description("区域")]
        [JsonIgnore]
        public string AreaId { get; set; }

        /// <summary>
        /// 操作状态
        /// </summary>
        [Description("操作状态")]
        public OperationStatus OperationStatus { get; set; }
    }
}
