﻿using Hotline.Repository.SqlSugar.Interface;
using Microsoft.Extensions.DependencyInjection;
using System.Reflection;
using System.Text.RegularExpressions;

namespace Exam.Infrastructure.Web.Utilities
{
    public static class ServiceUtility
    {
        public static IServiceCollection Services { get; set; }

        public static void RegisterService(this IServiceCollection services)
        {
            var assemblies = AssemblyUtility.GetAssembly(Assembly.GetExecutingAssembly().Location);

            var domainEvents = new List<IDomainService>();

            var apiServiceAssemblies = assemblies.Where(item => Regex.IsMatch(Path.GetFileNameWithoutExtension(item.CodeBase), Infrastructure.Utilities.BaseAssemblyUtility.VITRUALAPPLICATION)).ToList();

            foreach (var assembly in apiServiceAssemblies)
            {
                try
                {
                    
                    var types = assembly.GetTypes().Where(t => t.GetInterfaces().Contains(typeof(IDomainService)));

                    if (types == null || !types.Any()) continue;

                    var implements = types.Where(t => t.IsInterface != true);

                    var interfaces = types.Where(t => t.IsInterface == true);
                    //var eventTypes = assembly.GetTypes().Where(t => t.GetInterfaces().Contains(typeof(IBaseEvent)));

                    foreach (var item in interfaces)
                    {
                        var implement = implements.FirstOrDefault(t => t.GetInterfaces().Contains(item));
                        if (implement != null)
                        {
                            services.AddScoped(item, implement);
                        }
                    }

                    Services = services;
                }
                catch (Exception ex)
                {
                    continue;
                }
            }
        }

        public static T GetServic<T>()
        {
            if (Services != null)
            {
                var provider = Services.BuildServiceProvider();

                return provider.GetService<T>();
            }

            return default;
        }
    }
}
