﻿using Exam.Infrastructure.Data.Entity;
using Exam.Infrastructure.Data.Interface;
using Exam.Insfrastructure.Service.Entitys;

namespace Exam.Insfrastructure.Service.Interface
{
    public interface IApiService<T,TEntity>: IDomainService where T : IActionRequest
        where TEntity : class, IEntity<string>, new()
    {
        Task AddAsync(T actionRequest,CancellationToken cancellationToken);

        Task AddAsync(List<T> actionRequests, CancellationToken cancellationToken);

        Task UpdateAsync(T actionRequest, CancellationToken cancellationToken);

        Task UpdateAsync(List<T> actionRequests, CancellationToken cancellationToken);

        Task DeleteAsync(EntityQueryRequest entityQueryRequest, CancellationToken cancellationToken);

        Task UpdateStatus(List<StatusActionRequest> statusActionRequests, CancellationToken cancellationToken);

    }
}
