﻿using Exam.ExamManages;

using Exam.Share;
using Exam.Share.Dtos.ExamManage;
using Exam.Share.ViewResponses.Exam;
using Hotline.Repository.SqlSugar.Interface;
using Hotline.Share.Requests.Exam;

namespace Exam.Application.Interface.Exam
{
    public interface IUserExamService:IQueryService<UserExamResultViewResponse,UserExamDto,UserExamPagedRequest>,IApiService<UserExamDto,UserExam>
    {
        /// <summary>
        /// 交卷
        /// </summary>
        /// <param name="submitExamDto"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task SubmitAsync(SubmitExamDto submitExamDto,CancellationToken cancellationToken);
        
        /// <summary>
        /// 阅卷
        /// </summary>
        /// <param name="gradingExtamItemDto"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task GradingAsync(GradingExtamItemDto gradingExtamItemDto, CancellationToken cancellationToken);
    }
}
