﻿using Exam.Infrastructure.Data.Entity;
using System.ComponentModel;

namespace Exam.Share
{
    /// <summary>
    /// 用户考试
    /// </summary>
    [Description("用户考试")]
    public class UserExamDto:ActionRequest
    {
        /// <summary>
        /// 用户Id
        /// </summary>
        [Description("用户Id")]
        public string UserId { get; set; }

        /// <summary>
        /// 考试Id
        /// </summary>
        [Description("考试Id")]
        public string ExamId { get; set; }

        /// <summary>
        /// 考试分数
        /// </summary>
        [Description("考试分数")]
        public int Score { get; set; }

        /// <summary>
        /// 是否合格
        /// </summary>
        [Description("是否合格")]
        public bool IsSuccess { get; set; }

        /// <summary>
        /// 考试状态
        /// </summary>
        [Description("考试状态")]
        public int ExamStatus { get; set; }

        /// <summary>
        /// 是否已阅卷
        /// </summary>
        [Description("是否已阅卷")]
        public int IsCheck { get; set; }

        /// <summary>
        /// 用户考试明细
        /// </summary>
        [Description("用户考试明细")]
        public List<UserExamItemDto> UserExamItems { get; set; }
    }
}
